import sys
import unittest
import unittest.mock as mock

import hwhealth.tools as tools  # noqa: E402

sys.path.append("lib")


class TestIpmiSensor(unittest.TestCase):
    def test_create_exclusion(self):
        config_items = ['["~.*Link Down|Slot/Connector"]', "--extra-args"]
        with mock.patch("hwhealth.tools.Tool.__init__") as mock_tool_init:
            with mock.patch("hwhealth.tools.hookenv.config", side_effect=config_items):
                with mock.patch("hwhealth.tools.write_file") as mock_write:
                    tools.Ipmi()
        mock_tool_init.assert_called_with(
            cron_script="cron_ipmi_sensors.py",
            cron_script_args="--extra-args --sexclude /var/lib/nagios/ipmi_exclude",
        )
        mock_write.assert_called_with(
            "/var/lib/nagios/ipmi_exclude",
            "~.*Link Down|Slot/Connector",
            owner="root",
            group="root",
            perms=0o444,
        )
